---
title: Crisp pixel art look with image-rendering
slug: Games/Techniques/Crisp_pixel_art_look
tags:
  - 2D
  - 3D
  - CSS
  - Canvas
  - Games
  - JavaScript
  - WebGL
  - image-rendering
  - pixel
---
<div>{{GamesSidebar}}</div><p class="summary">This article discusses a useful technique for giving your canvas/WebGL games a crisp pixel art look, even on high definition monitors.</p>

<h2 id="The_concept">The concept</h2>

<p>Retro <a href="https://wikipedia.org/wiki/Pixel_art">pixel art</a> aesthetics are getting popular, especially in <a href="https://wikipedia.org/wiki/Indie_game">indie games</a> or <a href="https://wikipedia.org/wiki/Game_jam">game jam</a> entries. But since today's screens render content at high resolutions, there is a problem with making sure the pixel art does not look blurry. Developers have been manually scaling up graphics so they are shown with blocks that represent pixels. Two downsides to this method are larger file sizes and <a href="https://wikipedia.org/wiki/Compression_artifact">compression artifacts</a>.</p>

<table class="standard-table" style="margin: 0 auto 1.5em auto;">
 <tbody>
  <tr>
   <td style="text-align: center; vertical-align: middle;"><img alt="" src="https://mdn.mozillademos.org/files/13394/technique_original.png" style="height: 34px; width: 12px;"></td>
   <td style="text-align: center; vertical-align: middle;"><img alt="" src="https://mdn.mozillademos.org/files/13394/technique_original.png" style="height: 136px; width: 48px;"></td>
   <td style="text-align: center; vertical-align: middle;"><img alt="" src="https://mdn.mozillademos.org/files/13396/technique_4x.png" style="height: 136px; width: 48px;"></td>
  </tr>
  <tr>
   <td style="text-align: center;">original size</td>
   <td style="text-align: center;">4x size</td>
   <td style="text-align: center;">4x size (scaled with an image editor)</td>
  </tr>
  <tr>
   <td style="text-align: center;">none</td>
   <td style="text-align: center;">vendor's algorithm</td>
   <td style="text-align: center;"><a href="https://wikipedia.org/wiki/Nearest-neighbor_interpolation">nearest-neighbor algorithm</a></td>
  </tr>
 </tbody>
</table>

<h2 id="A_CSS-based_solution">A CSS-based solution</h2>

<p>The good news is that you can use CSS to automatically do the up-scaling, which not only solves the blur problem, but also allows you to use the images in their original, smaller size, thus saving download time. Also, some game techniques require algorithms that analyse images, which also benefit from working with smaller images.</p>

<p>The CSS property to achieve this scaling is {{cssxref("image-rendering")}}. It is still experimental, but there is partial support in most browsers. The steps to achieve this effect are:</p>

<ul>
 <li>Create a {{htmlelement("canvas")}} element and set its <code>width</code> and <code>height</code> attributes to the original, smaller resolution.</li>
 <li>Set its CSS {{cssxref("width")}} and {{cssxref("height")}} properties to be 2x or 4x the value of the HTML <code>width</code> and <code>height</code>. If the canvas was created with a 128 pixel width, for example, we would set the CSS <code>width</code> to <code>512px</code> if we wanted a 4x scale.</li>
 <li>Set the {{htmlelement("canvas")}} element's <code>image-rendering</code> CSS property to some value that does not make the image blurry. Either <code>crisp-edges</code> or <code>pixelated</code> will work. Check out the {{cssxref("image-rendering")}} article for more information on the differences between these values, and which prefixes to use depending on the browser.</li>
</ul>

<h2 id="An_example">An example</h2>

<p>Let's have a look at an example. The original image we want to upscale looks like this:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/12640/cat.png" style="display: block; margin: 0 auto;"></p>

<p>Here's some HTML to create a simple canvas:</p>

<pre class="brush: html">&lt;canvas id="game" width="128" height="128"&gt;&lt;/canvas&gt;</pre>

<p>CSS to size the canvas and render a crisp image:</p>

<pre class="brush: css"><code class="language-css"><span class="selector token">canvas </span><span class="punctuation token">{</span>
  </code>width: 512px;
  height: 512px;<code class="language-css">
  <span class="property token">image-rendering</span><span class="punctuation token">:</span> -moz-crisp-edges<span class="punctuation token">;</span>
  <span class="property token">image-rendering</span><span class="punctuation token">:</span> -webkit-crisp-edges<span class="punctuation token">;</span>
  <span class="property token">image-rendering</span><span class="punctuation token">:</span> pixelated<span class="punctuation token">;
  image-rendering: crisp-edges;</span>
<span class="punctuation token">}</span>
</code></pre>

<p>And some JavaScript to set up the canvas and load the image:</p>

<pre class="brush: js">// get canvas context
var ctx = document.getElementById('game').getContext('2d');
// load image
var image = new Image();
image.onload = function () {
    // draw the image into the canvas
    ctx.drawImage(image, 0, 0);
}
image.src = 'https://mdn.mozillademos.org/files/12640/cat.png';</pre>

<p>This code used together produces the following result:</p>

<p>{{ EmbedLiveSample('An_example', '100%', 520) }}</p>

<div class="note">
<p><strong>Note</strong>: You can check out the <a href="https://github.com/belen-albeza/retro-canvas">original code on Github</a> (<a href="https://belen-albeza.github.io/retro-canvas/">and a live example</a>.)</p>
</div>
